LeetCode - LCR 008.长度最小的子数组

一. 题目链接

LeetCode - 209. 长度最小的子数组

二. 思路分析

由于此问题分析的对象是「⼀段连续的区间」,因此可以考虑**「滑动窗口」**的思想来解决这道题。 让滑动窗口满足:从 i 位置开始,窗口内所有元素的和小于target (那么当窗口内元素之和 第⼀次大于等于目标值的时候,就是i 位置开始,满足条件的最小长度)。

做法:将右端元素划入窗口中,统计出此时窗口内元素的和:

**如果窗口内元素之和大于等于target :**更新结果,并且将左端元素划出去,继续判断是否满足条件并更新结果(因为左端元素可能很小,划出去之后依旧满足条件)

如果窗口内元素之和不满足条件: right++ ,另下⼀个元素进入窗口。

为何滑动窗口可以解决问题,并且时间复杂度更低?

这个窗口寻找的是:以当前窗口最左侧元素(记为 left1 )为基准,符合条件的情况。也 就是在这道题中,从left1 开始,满租区间和sum >= target 时的最右侧(记为 right1 )能到哪里。

我们既然已经找到从left1 开始的最优的区间,那么就可以⼤胆舍去left1 。但是如 果继续像⽅法⼀⼀样,重新开始统计第⼆个元素( left2 )往后的和,势必会有⼤量重复 的计算(因为我们在求第⼀段区间的时候,已经算出很多元素的和了,这些和是可以在计算 下次区间和的时候⽤上的)。

此时, rigth1 的作用就体现出来了,我们只需将left1 这个值从sum 中剔除。从 right1 这个元素开始,往后找满足left2 元素的区间(此时right1 也有可能是满 ⾜的,因为left1 可能很⼩。 sum 剔除掉left1 之后,依旧满足大于等于 target )。这样我们就能省掉大量重复的计算。

三. 动画分析

四. 代码解释

cpp 复制代码
class Solution {
public:
    int minSubArrayLen(int target, vector<int>& nums) 
    {
        int left = 0;
        int right = 0;
        int len = INT_MAX;
        int res = 0;
        while (right < nums.size())
        {
            res += num[right++];
                while (res > target)
                {
                    len = min(len,right - left +1);
                    sum -= num[left--];
                }
                return len = INT_MAX ?0 : len;
        }
    }
};
相关推荐
学术小李18 分钟前
cudaMalloc第一个参数为何是指针的指针
算法
kukubuzai21 分钟前
二分查找系列一
数据结构·算法·leetcode
老歌老听老掉牙25 分钟前
动态规划:从递归到最优决策的算法艺术
算法·动态规划
朔北之忘 Clancy27 分钟前
2024 CSP-J 第二轮真题解析
c++·算法·青少年编程·noip·csp·信奥赛·noi
小七在进步1 小时前
类和对象(五)
java·开发语言·算法
就叫年华吧丶1 小时前
长文档点目录定位总是不准?一个 content-visibility + 平滑滚动引发的连环坑(Vue3 实战)
前端·javascript·算法·vue
FPGA信号处理1 小时前
【信号检测与估计】第四节课:非高斯噪声下的 BLUE、极大似然与 EM 算法
人工智能·算法·机器学习
.道阻且长.2 小时前
C++ 11:可变参数模板
前端·c++·算法
Doubbbbbbble云4 小时前
基于贪心算法的区间覆盖问题求解策略4
算法·贪心算法